/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.hadoop.chukwa.extraction.engine.datasource.record;


import java.util.List;
import org.apache.hadoop.chukwa.extraction.engine.ChukwaRecordKey;
import org.apache.hadoop.chukwa.extraction.engine.Record;

public class ChukwaDSInternalResult {
  List<Record> records = null;
  String day = null;
  int hour = 0;
  int rawIndex = 0;
  int spill = 1;
  long position = -1;
  long currentTs = -1;

  String fileName = null;

  ChukwaRecordKey key = null;
  
  public ChukwaRecordKey getKey() {
    return key;
  }
  
  protected void setKey(ChukwaRecordKey key) {
    this.key = key;
  }
}
